/* AP 15-sep-12	textstore.c						*/
/*		ein Beispiel zur Verwendung von alloc() und afree()	*/

# include <stdio.h>
# include <string.h>
# include <stdlib.h>
# include "alloc.h"

/*
# define alloc malloc
# define afree free
*/

# define LINES 5
# define LEN 80

int main( int argc, char *argv[] ) {
	char* lines[LINES];
	char* *next = lines;
	char buf[LEN];

	while (1) {
		printf("Command: n <text>, d (elete), p (rint) q (quit)\n");
		memset( buf, '\0', LEN );
		/* gets( buf ); */
		fgets( buf, LEN, stdin );
		if (buf[LEN-1] == '\0') {
			/* fgets() hat Zeilenumbruch angehaengt */
			buf[ strlen(buf)-1 ] = '\0';
		}
		switch( buf[0] ) {
			case 'n': 
				if (next - lines >= LINES) {
					printf("sorry, we´re full\n");
					continue;
				}
				*next = alloc( strlen(&buf[2])+1 );
				if (! *next) {
					printf("heap exhausted\n");
					continue;
				}
				strcpy( *next, &buf[2] );
				next++;
				break;
			case 'p':
				if (next == lines) {
					printf("nothing stored\n");
					continue;
				}
				printf( "%s\n", *(next-1) );
				break;
			case 'd':
				if (next == lines) {
					printf("nothing to delete\n");
					continue;
				}
				next--;
				afree( *next );
				printf("One line deleted\n");
				break;
			case 'q':
				return 0;
			default:
				break;
		}
	}
}


