/* AP 18-sep-12	textstore2.c						*/
/*		ein Beispiel zur Verwendung von malloc() und free()	*/

# include <stdio.h>
# include <string.h>
# include <stdlib.h>

# define LINES 20
# define LEN 80

int main( int argc, char *argv[] ) {
	char* lines[LINES];
	char* *next = lines;
	char* *curr = NULL;
	char* *p;
	char buf[LEN];

	while (1) {
		printf("Command: n <text>, d (elete), "
			"+, -, p (rint) q (quit)\n");
		memset( buf, '\0', LEN );
		/* gets( buf ); */
		fgets( buf, LEN, stdin );
		if (buf[LEN-1] == '\0') {
			/* fgets() hat Zeilenumbruch angehaengt */
			buf[ strlen(buf)-1 ] = '\0';
		}
		switch( buf[0] ) {
			case 'n': 
				if (next - lines >= LINES) {
					printf("sorry, we´re full\n");
					continue;
				}
				if (! curr) 
					curr = next;
				else
					curr++;
				p = next;
				next++;
				while (p != curr) {
					*p = *(p-1);	
					p--;
				}
				*curr = malloc( strlen(&buf[2])+1 );
				if (! *curr) {
					printf("heap exhausted\n");
					continue;
				}
				strcpy( *curr, &buf[2] );
				break;
			case 'p':
				if (! curr) {
					printf("nothing stored\n");
					continue;
				}
				printf( "%s\n", *curr );
				break;
			case 'd':
				if (! curr) {
					printf("nothing to delete\n");
					continue;
				}
				free( *curr );
				p = curr;
				while (p+1 != next) {
					*p = *(p+1);	
					p++;
				}
				next--;
				if (curr == next)
					curr --;
				if (next == lines)
					curr = NULL;
				printf("One line deleted\n");
				break;
			case '+':
				if (! curr) {
					printf("empty\n");
					continue;
				}
				if (curr+1 == next) {
					printf("already at top\n");
					continue;
				}
				curr++;
				printf( "%s\n", *curr );
				break;
			case '-':
				if (! curr) {
					printf("empty\n");
					continue;
				}
				if (curr == lines) {
					printf("already at bottom\n");
					continue;
				}
				curr--;
				printf( "%s\n", *curr );
				break;
			case 'q':
				return 0;
			default:
				break;
		}
	}
}


